#pragma once
#include "CommonData.h"
#include "CVariant.h"

class CCommon
{
public:
	CCommon();
	~CCommon();
	//const char*ַתɿַַ
	static wstring StrToUnicode(const char* str, bool utf8 = false);

	static string UnicodeToStr(const wchar_t* wstr, bool utf8 = false);

	static void StringNormalize(wstring& str);

	/*ݵĴСתKBMBGBΪλַ
	sizeݵֽ
	ֵתַ
	*/
	static CString DataSizeToString(unsigned int size, const PublicSettingData& cfg);
	static CString DataSizeToString(unsigned long long size);

	static CString KBytesToString(unsigned int kb_size);
	static CString KBytesToStringL(__int64 kb_size);

	//FILETIMEṹʱ
	static __int64 CompareFileTime2(FILETIME time1, FILETIME time2);

	//һ־Ϣstr_textд뵽file_pathļ
	static void WriteLog(const char* str_text, LPCTSTR file_path);
	static void WriteLog(const wchar_t* str_text, LPCTSTR file_path);

	/*
	ܣָļָĿ¼´ݷʽ
	
	lpszLnkFileDir  ָĿ¼ΪNULL
	lpszFileName    ָļΪNULLʾǰ̵EXEļ
	lpszLnkFileName ݷʽƣΪNULLʾEXEļ
	wHotkey         Ϊ0ʾÿݼ
	pszDescription  ע
	iShowCmd        зʽĬΪ洰
	*/
	static BOOL CreateFileShortcut(LPCTSTR lpszLnkFileDir, LPCTSTR lpszFileName = NULL, LPCTSTR lpszLnkFileName = NULL, LPCTSTR lpszWorkDir = NULL, WORD wHotkey = 0, LPCTSTR lpszDescription = NULL, int iShowCmd = SW_SHOWNORMAL);

	//ȡʼ˵геġĿ¼·
	static wstring GetStartUpPath();

	//ȡpath·µļļУļļƱfilesС
	static void GetFiles(const wchar_t* path, vector<wstring>& files);

	//жһļǷ
	static bool FileExist(LPCTSTR file_name);

	static bool MoveAFile(LPCTSTR exist_file, LPCTSTR new_file);

	//SYSTEMTIMEṹʱĲa-bֻʱ֡룩
	static SYSTEMTIME CompareSystemTime(SYSTEMTIME a, SYSTEMTIME b);

	//ȡǰĿ¼
	static wstring GetModuleDir();

	//ȡsystem32ļе·
	static wstring GetSystemDir();

	//ȡʱļе·
	static wstring GetTemplateDir();

	//ȡAppdata/Local/TrafficMonitorĿ¼ڣԶ
	static wstring GetAppDataConfigDir();

	//ָλûı
	static void DrawWindowText(CDC* pDC, CRect rect, LPCTSTR lpszString, COLORREF color, COLORREF back_color);

	////ûͼļ
	//static void SetDrawArea(CDC* pDC, CRect rect);

	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	* ƣIsForegroundFullscreen
	* ˵жϵǰûǰ̨Ƿȫġ
	* ˵
	* ˵trueǡ
	false
	* ̰߳ȫ
	* IsForegroundFullscreen ()ʾжϵǰûǰ̨Ƿȫġ
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	static bool IsForegroundFullscreen();

	//һַ浽
	static bool CopyStringToClipboard(const wstring& str);

	//ȡURL
	static bool GetURL(const wstring& url, wstring& result, bool utf8 = false);

	//ȡIPַIP
	static void GetInternetIp(wstring& ip_address, wstring& ip_location, bool global);

	static void SetRect(CRect& rect, int x, int y, int width, int height);

	//ԴļַУfront_strback_strΪַʱҪǰӵַ
	static CString LoadText(UINT id, LPCTSTR back_str = nullptr);
	static CString LoadText(LPCTSTR front_str, UINT id, LPCTSTR back_str = nullptr);

	//ȫĸʽַformat_str<%%>ַ滻ɳʼбparasеԪأԪ֧int/double/LPCTSTR/CStringʽŴ1ʼ
	static CString StringFormat(LPCTSTR format_str, const std::initializer_list<CVariant>& paras);

	//ԴļַԴַ<%%>ַ滻ɿɱбеĲ
	static CString LoadTextFormat(UINT id, const std::initializer_list<CVariant>& paras);

	//intתַ
	//nҪתֵ
	//thousand_separationǷҪÿ3λʹöŷָ
	//is_unsignedֵǷ޷ŵ
	static CString IntToString(int n, bool thousand_separation = false, bool is_unsigned = false);

	//ɾƺBoldLightַЩַϸ
	static void NormalizeFont(LOGFONT& font);

	//ȫַƺ
	static void WStringCopy(wchar_t* str_dest, int dest_size, const wchar_t* str_source, int source_size = INT_MAX);

	/// <summary>
	/// ַƶ㷨-༭뷨
	/// </summary>
	/// <returns>صֵΪ0~1ԽƶԽ</returns>
	static double StringSimilarDegree_LD(const string& srcString, const string& matchString);

	//߳
	static void SetThreadLanguage(Language language);

	//ɫģʽ
	static void SetColorMode(ColorMode mode);

	static void SetDialogFont(CWnd* pDlg, CFont* pFont);
};

